#include <bits/stdc++.h>

using namespace std;
#define int long long
int ans[200001][2];
int a[200001];
int32_t main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n; cin >> n;
    int bot = 0;
    int curr = 0;
    for(int i=0;i<n;i++){
        int x; cin >> x;
        a[i]=x;
        if(x<curr){
            bot = i;
        }
        curr = x;
        ans[i][0]=bot;
        ans[i][1]=ans[i][0];
        ans[i][1]=min(ans[i][1],ans[bot][1]);
        if(i)ans[i][1]=min(ans[i][1],ans[i-1][0]);
        if(bot>1&&a[bot-2]<=a[i])ans[i][1]=min(ans[i][1],ans[bot-2][0]);
    }
    int q; cin >> q;
    for(int i=0;i<q;i++){
        int l,r; cin >> l >> r;
        l--;r--;
        (l<ans[r][1])?cout << "NE\n":cout <<"DA\n";
    }
    return 0;
}